/* Copyright (c) 2008 Boulder Real Time Technologies, Inc. */
/* All rights reserved */
 
/* This software module is wholly owned by Boulder Real Time 
   Technologies, Inc. This software may be used freely in any 
   way as long as the copyright statement above is not removed. */

#ifndef _import_
#define _import_

#include "stock.h"
#include "orbwfproc.h"
#include "brttpkt.h"

typedef struct import_ {
	char input_type[32];
	char orbname[128];
	char dbname[128];
	char select[512];
	char reject[512];
	char start[512];
	char end[512];
	int calibfromdb;
	int process_through_unstuff_errors;
	double starttime;
	double endtime;
	double backup;
	double told;
	double too_old;
	double too_new;
	Tbl *chan_accept;
	Tbl *chan_reject;
	int verbose;
	int orb;
	OrbreapThr *orbth;
	WFProcDb *wfpdbin;
	double pause_timeout;
	Dbptr dbin;
	Dbptr dbtr;
	int nchannels;
	struct channels_ {
		char sta[32];
		char chan[32];
		char snet[32];
		char ssta[32];
		char schan[32];
		char sloc[32];
		long rec;
		long erec;
	}  *channels;
	double time_slice_duration;
	double time_slice_time;
	double time_slice_endtime;
	PktChannel2Trace *pt;
	size_t heap_throttle;
	Hook *calib_hook;
	float gap_value;
} Import;

typedef struct wf_obj_params_ {
	Tbl *translations_tbl;
} WFObjParams;

void *import_new (Pf *params);
int import_destroy (void *wfav);
int import_config (void *wfav, Pf *params, Pf *state);
int import_proc (void *wfav, WFProcData *input, Tbl **output, Pf **state);
void import_data_free (WFProcData *packet);
WFProcData *import_data_copy (WFProcData *packet);
int import_data_topkt (WFProcData *packet, Tbl *translations, Tbl *pkts_tbl);
char *import_data_print (WFProcData *packet, int verbose);

#endif
